#include"ElementClass.h"
#include"ThreeNodeShell.h"
#include"Quadralateral2D.h"
#include"Beam.h"

ElementClass*
ElementClass::build(int type,int size, int* node){
	ElementClass* ele;
		switch(type){
			case THREENODESHELL:
				ele=new ThreeNodeShell(size,node);
				break;
			case COMPO3NODESHELL:
				ele=new ThreeNodeShell(size,node);
				break;
			case FOURNODEQUAD:
				ele=new Quadralateral2D(size,node);
			break;
			case TWONODETRUSS:
				ele=new Beam(size,node);
			break;
			case EULERBEAM:
				ele=new Beam(size,node);
			break;
			case TIMOSHENKOBEAM:
				ele=new Beam(size,node);
			break;
			default:
				ele=NULL;
			break;
		}
	return ele;
}

ostream& 
operator<<(ostream& os, ElementClass& source){
	int i,num;
	
	num=source.numNodes();
	for(i=0;i<num-1;i++)
		os<<(source.getNode(i)+1)<<' ';
	os<<(source.getNode(num-1)+1);
	return os;
}



