#include <cstdio>
#include"Quadralateral2D.h"
#include"Beam.h"
Quadralateral2D::Quadralateral2D(int inSize, int* inNodes){
	assert(inSize==4);
	nodes[0]=inNodes[0];
	nodes[1]=inNodes[1];
	nodes[2]=inNodes[2];
	nodes[3]=inNodes[3];
}

int 
Quadralateral2D::getNode(int position){
	assert(0<position);
	assert(position<=1);
	return nodes[position];
}

void Quadralateral2D::match(ResizeArray<Point3D*>& allPoints,
const Point3D& matchPoint, const double tol, MatchInfo& info)const{
	int i;
	int inNodes[4][2];
	MatchInfo temp;
	inNodes[0][0]=nodes[0];
	inNodes[0][1]=nodes[1];
	inNodes[1][0]=nodes[1];
	inNodes[1][1]=nodes[2];
	inNodes[2][0]=nodes[3];
	inNodes[2][1]=nodes[2];
	inNodes[3][0]=nodes[0];
	inNodes[3][1]=nodes[3];
	info.dist=1000000.0;
	info.success=0;
	for(i=0;i<4;i++){
		Beam B(2,inNodes[i]);
		B.match(allPoints,matchPoint,tol,temp);
		if(temp.success==1&&temp.dist<info.dist){
			info=temp;
			switch(i){
				case 0:
					info.eta=0.0;
				break;
				case 1:
					info.eta=info.xi;
					info.xi=1.0;
				break;
				case 2:
					info.eta=1.0;
				break;
				case 3:
					info.eta=info.xi;
					info.xi=0.0;
				break;
			}
		}
	}
}


//---------------------------------------------------------------
/*
void Quadralateral2D::binWriteNodes(BinFileHandler &outfile) {

  outfile.write(nn, 4);

}
*/
