#include <aux.h>

BCList::BCList()
{
 maxbc = 32;
 d     = new BCond[maxbc];
 n     = 0;
}

void
BCList::add(BCond&bc)
{
 if(n == maxbc) {
   int nmaxbc = (3*maxbc)/2;
   BCond *nd = new BCond[nmaxbc];
   int i;
   for(i=0; i < maxbc; ++i)
      nd[i] = d[i];
   delete [] d;
   d = nd;
   maxbc = nmaxbc;
 }
 d[n++] = bc;
}

/*
ComplexBCList::ComplexBCList()
{
 maxbc = 32;
 d     = new ComplexBCond[maxbc];
 n     = 0;
}

void
ComplexBCList::add(ComplexBCond &bc)
{
 if(n==maxbc) {
   int nmaxbc = (3*maxbc)/2;
   ComplexBCond *nd = new ComplexBCond[nmaxbc];
   int i;
   for(i=0; i < maxbc; ++i)
      nd[i] = d[i];
   delete[] d;
   d = nd;
   maxbc=nmaxbc;
 }
 d[n++] = bc;
}
*/

//-------------------------------------------------------------------

void CoefData::zero()  {

  for (int i = 0; i < 6; i++)
    for (int j = 0; j < 6; j++)
      c[i][j] = 0.0;
}

//-------------------------------------------------------------------

void CoefData::setCoef(int i, int j, double v)  {

  if (i < 0 || j < 0 || i >= 6 || j >= 6)
    fprintf(stderr,"ERROR: in coefficient data:"
                   " out of bound indices %d %d\n", i+1, j+1);
 
  c[i][j] = c[j][i] = v;
}

//-------------------------------------------------------------------

LayInfo::LayInfo(int _type)  {

  type      = _type;
  maxLayer  = 4;
  numLayers = 0;
  data      = new double[maxLayer][9];
  grad      = new double[maxLayer][9];
}

//-------------------------------------------------------------------

void LayInfo::add(int ln, double *v)  {

  int i,j;

  //allocate
  if (ln >= maxLayer) {
    int newMaxLayer = (ln+4);
    double (*newData)[9] = new double[newMaxLayer][9];
    for(i=0; i < numLayers; ++i)
      for(j=0; j < 9; ++j)
         newData[i][j] = data[i][j];
   delete [] data;
   data     = newData;
   maxLayer = newMaxLayer;
  }
  if(ln >= numLayers) numLayers = ln+1;
  for(i=0; i < 9; ++i)
    data[ln][i] = v[i];
}

